﻿using System;
using System.Windows.Forms;

namespace MarkusGrothoff.Media {

    /// <summary>
    /// Stellen Objekte dar, die aufgrund von Callback der Windows Mci-Api Events auslösen.
    /// </summary>
    internal class MciCallbackControl : Control {

        internal delegate void NotifyMessageReceivedHandler(Object sender, NotifyMessageReceivedEventArgs e);
        internal event NotifyMessageReceivedHandler NotifyMessageReceived = null;

        private const int Notify = 0x3b9;

        protected override void WndProc(ref Message m) {
            if (m.Msg == Notify) {
                OnNotifyMessageReceived(new NotifyMessageReceivedEventArgs((MciApi.NotifyMessage)m.WParam.ToInt32()));
            }
            base.WndProc(ref m);
        }

        /// <summary>
        /// Löst das NotifyMessageReceived-Event aus.
        /// </summary>
        protected virtual void OnNotifyMessageReceived(NotifyMessageReceivedEventArgs e) {
            if (NotifyMessageReceived != null) {
                NotifyMessageReceivedHandler notifyMessageReceived = (NotifyMessageReceivedHandler)NotifyMessageReceived.Clone();
                if (notifyMessageReceived != null) notifyMessageReceived(this, e);
            }
        }
    }
}